using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using RainbowLibraryCE.Common;
using System.IO;
using RainbowLibraryCE.Misc;

namespace PocketRassegnaRAI
{
    public partial class frmSettings : Form
    {
        public frmSettings()
        {
            InitializeComponent();
        }

        public void LoadSettings()
        {
            txtApplicationPath.Text = GlobalVars.Settings.PDFAppPath;
            txtCachePath.Text = GlobalVars.Settings.CachePath;
        }

        private void inputPanel1_EnabledChanged(object sender, EventArgs e)
        {
            if (inputPanel1.Enabled)
                this.Height = this.Height - inputPanel1.Bounds.Height;
            else
                this.Height = this.Height + inputPanel1.Bounds.Height;
        }

        private void menuItemOk_Click(object sender, EventArgs e)
        {
            CRainbowAppSettings<CSettings> objSettingsHandler;

            Cursor.Current = Cursors.WaitCursor;
            GlobalVars.Settings.PDFAppPath = txtApplicationPath.Text;
            objSettingsHandler = new CRainbowAppSettings<CSettings>(GlobalVars.Settings, GlobalVars.SettingFilePath);
            objSettingsHandler.SaveSettings();
            Cursor.Current = Cursors.Default;

            this.Close();
        }

        private void menuItemCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnClearCache_Click(object sender, EventArgs e)
        {
            if (!Directory.Exists(GlobalVars.Settings.CachePath))
            {
                MessageBox.Show("Il percorso specificato non esiste!", GlobalVars.ProgName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                return;
            }   
                
            if (DialogResult.Yes == MessageBox.Show("Cancellare il contenuto delle cache?", GlobalVars.ProgName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2))
            {
                try
                {
                    Directory.Delete(GlobalVars.Settings.CachePath, true);
                    MessageBox.Show("Cache cancellata", GlobalVars.ProgName, MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
                }
                catch (Exception objEx)
                {
                    MessageBox.Show("Problemi nella cancellazione della cache:\n" + objEx.Message, GlobalVars.ProgName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);
                }
            }
        }

        private void btnGetApplicationFromRegistry_Click(object sender, EventArgs e)
        {
            string strAppPath;

            strAppPath = RegistryHelper.GetDefaultApplication(".pdf");
            if (String.Empty == strAppPath)
                MessageBox.Show("Spiacente, nessun programma associato ai file .PDF", GlobalVars.ProgName, MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1);
            else
                txtApplicationPath.Text = strAppPath;
        }

        private void btnChooseApplicationManually_Click(object sender, EventArgs e)
        {
            frmFileSelect objFileDialog;

            Cursor.Current = Cursors.WaitCursor;
            objFileDialog = new frmFileSelect("*.exe");
            Cursor.Current = Cursors.Default;
            objFileDialog.ShowDialog();
            if (objFileDialog.DialogResult == DialogResult.OK)
                txtApplicationPath.Text = objFileDialog.FileName;
            objFileDialog.Dispose();
        }
    }
}